(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(require('worker-factory'), require('@babel/runtime/helpers/classCallCheck'), require('@babel/runtime/helpers/createClass')) :
    typeof define === 'function' && define.amd ? define(['worker-factory', '@babel/runtime/helpers/classCallCheck', '@babel/runtime/helpers/createClass'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.workerFactory, global._classCallCheck, global._createClass));
})(this, (function (workerFactory, _classCallCheck, _createClass) { 'use strict';

    var ArrayBufferStore = /*#__PURE__*/function () {
      function ArrayBufferStore() {
        _classCallCheck(this, ArrayBufferStore);
        this._store = new Map();
      }
      return _createClass(ArrayBufferStore, [{
        key: "clone",
        value: function clone(id) {
          var arrayBuffer = this._store.get(id);
          if (arrayBuffer === undefined) {
            throw new Error("There is no arrayBuffer stored with an id called \"".concat(id, "\"."));
          }
          return arrayBuffer.slice(0);
        }
      }, {
        key: "purge",
        value: function purge(id) {
          var arrayBufferExisted = this._store["delete"](id);
          if (!arrayBufferExisted) {
            throw new Error("There is no arrayBuffer stored with an id called \"".concat(id, "\"."));
          }
        }
      }, {
        key: "slice",
        value: function slice(id, begin, end) {
          var arrayBuffer = this._store.get(id);
          if (arrayBuffer === undefined) {
            throw new Error("There is no arrayBuffer stored with an id called \"".concat(id, "\"."));
          }
          if (begin < 0 || begin > arrayBuffer.byteLength) {
            throw new Error("The given value for begin \"".concat(begin, "\" is out of bounds."));
          }
          if (end !== null) {
            if (end > arrayBuffer.byteLength) {
              throw new Error("The given value for end \"".concat(end, "\" is out of bounds."));
            }
            if (end < begin) {
              throw new Error("The given value for end \"".concat(end, "\" is below the given value for begin \"").concat(begin, "\"."));
            }
          }
          return arrayBuffer.slice(begin, end === null ? arrayBuffer.byteLength : end);
        }
      }, {
        key: "store",
        value: function store(id, arrayBuffer) {
          if (this._store.has(id)) {
            throw new Error("There is already an arrayBuffer stored with an id called \"".concat(id, "\"."));
          }
          this._store.set(id, arrayBuffer);
        }
      }]);
    }();

    var arrayBufferStore = new ArrayBufferStore();
    workerFactory.createWorker(self, {
      clone: function clone(_ref) {
        var arrayBufferId = _ref.arrayBufferId;
        var arrayBuffer = arrayBufferStore.clone(arrayBufferId);
        return {
          result: arrayBuffer,
          transferables: [arrayBuffer]
        };
      },
      purge: function purge(_ref2) {
        var arrayBufferId = _ref2.arrayBufferId;
        arrayBufferStore.purge(arrayBufferId);
        return {
          result: null
        };
      },
      slice: function slice(_ref3) {
        var arrayBufferId = _ref3.arrayBufferId,
          begin = _ref3.begin,
          end = _ref3.end;
        var arrayBuffer = arrayBufferStore.slice(arrayBufferId, begin, end);
        return {
          result: arrayBuffer,
          transferables: [arrayBuffer]
        };
      },
      store: function store(_ref4) {
        var arrayBuffer = _ref4.arrayBuffer,
          arrayBufferId = _ref4.arrayBufferId;
        arrayBufferStore.store(arrayBufferId, arrayBuffer);
        return {
          result: null
        };
      }
    });

}));
